<?php

namespace Modules\Cadastros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Gql01800QualificacaoProdutoFornecedorService
{
    protected $connection;
    
    public function __construct($entityManager, $environment)
    {
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    /********************
     *      SELECTS     *
     * ******************/

    public function getVerificaInserirAlterar($row)
    {
		$param = array(
		    'P_CDFORNECED'  => $row['P_CDFORNECED'],
		    'P_CDPRODUTO'   => $row['P_CDPRODUTO']
		);
		
        $query = "SELECT CDPRODUTO 
                    FROM QFOPRODFORN 
                   WHERE CDFORNECED = :P_CDFORNECED 
                     AND CDPRODUTO  = :P_CDPRODUTO";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function selectOperador($row)
    {
        $params = array(
            'P_CDOPERADOR' => $row['CDOPERADOR']
                
        );
        
        $query = "SELECT
                    CDOPERADOR,
                    NMOPERADOR,
                    CDSENHOPER
                FROM
                    OPERADOR
                WHERE
                    CDOPERADOR = :P_CDOPERADOR";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      INSERTS     *
     ********************/
     
     public function insertQualificacaoProdutoFornecedor($row)
    {
		$param = array(
		    'P_CDFORNECED'  => $row['P_CDFORNECED'],
		    'P_CDPRODUTO'   => $row['P_CDPRODUTO'],
		    'P_DTVALPRFORN' => $row['P_DTVALPRFORN'],
		    'P_IDFORNAPROV' => $row['P_IDFORNAPROV'],
		    'P_IDFORNAUTOR' => 'N'
		);
		
        $query = "INSERT INTO QFOPRODFORN 
                     (CDFORNECED, CDPRODUTO, DTVALPRFORN, IDFORNAPROV, IDFORNAUTOR)
                  VALUES 
                     (:P_CDFORNECED, :P_CDPRODUTO, :P_DTVALPRFORN, :P_IDFORNAPROV, :P_IDFORNAUTOR)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
     
     /*******************
     *      UPDATES     *
     ********************/
     
     public function UpdateQualificacaoProdutoFornecedor($row)
    {
		$param = array(
		    'P_CDFORNECED'  => $row['P_CDFORNECED'],
		    'P_CDPRODUTO'   => $row['P_CDPRODUTO'],
		    'P_DTVALPRFORN' => $row['P_DTVALPRFORN'],
		    'P_IDFORNAPROV' => $row['P_IDFORNAPROV'],
		    'P_IDFORNAUTOR' => $row['P_IDFORNAUTOR']
		);
		
        $query = "UPDATE QFOPRODFORN
                  SET
                    CDFORNECED  = :P_CDFORNECED,
                    CDPRODUTO   = :P_CDPRODUTO,
                    DTVALPRFORN = :P_DTVALPRFORN,
                    IDFORNAPROV = :P_IDFORNAPROV,
                    IDFORNAUTOR = :P_IDFORNAUTOR
                  WHERE
                    CDFORNECED  = :P_CDFORNECED AND
                    CDPRODUTO   = :P_CDPRODUTO";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }

     /*******************
     *      DELETES     *
     ********************/
     
     public function deleteQualificacaoProdutoFornecedor ($row)
    {
		$param = array(
		    'P_CDFORNECED' => $row['P_CDFORNECED'],
		    'P_CDPRODUTO'  => $row['P_CDPRODUTO']
		);
		
        $query = "DELETE FROM QFOPRODFORN
                   WHERE CDFORNECED = :P_CDFORNECED 
                     AND CDPRODUTO  = :P_CDPRODUTO";

        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
}